<?php

namespace \Losc\CucmBundle\Model\Webservice\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for XImeRouteFilterElement StructType
 * @subpackage Structs
 */
class XImeRouteFilterElement extends AbstractStructBase
{
    /**
     * The name
     * Meta information extracted from the WSDL
     * - base: xsd:string
     * - maxLength: 50
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: false
     * @var string
     */
    public $name;
    /**
     * The imeRouteFilterGroupName
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: false
     * @var \\Losc\CucmBundle\Model\Webservice\StructType\XFkType
     */
    public $imeRouteFilterGroupName;
    /**
     * The description
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: false
     * @var string
     */
    public $description;
    /**
     * The elementType
     * Meta information extracted from the WSDL
     * - default: Domain
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: false
     * @var string
     */
    public $elementType;
    /**
     * Constructor method for XImeRouteFilterElement
     * @uses XImeRouteFilterElement::setName()
     * @uses XImeRouteFilterElement::setImeRouteFilterGroupName()
     * @uses XImeRouteFilterElement::setDescription()
     * @uses XImeRouteFilterElement::setElementType()
     * @param string $name
     * @param \\Losc\CucmBundle\Model\Webservice\StructType\XFkType $imeRouteFilterGroupName
     * @param string $description
     * @param string $elementType
     */
    public function __construct($name = null, \\Losc\CucmBundle\Model\Webservice\StructType\XFkType $imeRouteFilterGroupName = null, $description = null, $elementType = 'Domain')
    {
        $this
            ->setName($name)
            ->setImeRouteFilterGroupName($imeRouteFilterGroupName)
            ->setDescription($description)
            ->setElementType($elementType);
    }
    /**
     * Get name value
     * @return string
     */
    public function getName()
    {
        return $this->name;
    }
    /**
     * Set name value
     * @param string $name
     * @return \\Losc\CucmBundle\Model\Webservice\StructType\XImeRouteFilterElement
     */
    public function setName($name = null)
    {
        $this->name = $name;
        return $this;
    }
    /**
     * Get imeRouteFilterGroupName value
     * @return \\Losc\CucmBundle\Model\Webservice\StructType\XFkType
     */
    public function getImeRouteFilterGroupName()
    {
        return $this->imeRouteFilterGroupName;
    }
    /**
     * Set imeRouteFilterGroupName value
     * @param \\Losc\CucmBundle\Model\Webservice\StructType\XFkType $imeRouteFilterGroupName
     * @return \\Losc\CucmBundle\Model\Webservice\StructType\XImeRouteFilterElement
     */
    public function setImeRouteFilterGroupName(\\Losc\CucmBundle\Model\Webservice\StructType\XFkType $imeRouteFilterGroupName = null)
    {
        $this->imeRouteFilterGroupName = $imeRouteFilterGroupName;
        return $this;
    }
    /**
     * Get description value
     * @return string|null
     */
    public function getDescription()
    {
        return $this->description;
    }
    /**
     * Set description value
     * @param string $description
     * @return \\Losc\CucmBundle\Model\Webservice\StructType\XImeRouteFilterElement
     */
    public function setDescription($description = null)
    {
        $this->description = $description;
        return $this;
    }
    /**
     * Get elementType value
     * @return string|null
     */
    public function getElementType()
    {
        return $this->elementType;
    }
    /**
     * Set elementType value
     * @param string $elementType
     * @return \\Losc\CucmBundle\Model\Webservice\StructType\XImeRouteFilterElement
     */
    public function setElementType($elementType = 'Domain')
    {
        $this->elementType = $elementType;
        return $this;
    }
}
